<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\Manager;
use Teknisa\MAN\Utilities;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\ParameterBag;

class ConsumidorRestricaoAliemtar extends CrudWithParameterBag{
    
    protected $dataSourceName = 'consumidor_restricaoAlimentar';
    protected $parameterBagColumns = array("CDCCUSCLIE","CDCLIENTE","NRORG","TCDCCUSCLIE","CDFILIAL","CDTIPOCONS","TCDTIPOCONS");
    protected $service;
    protected $util;
    
    public function __construct (Manager $dataSourceManager, ParameterBag $parameterBag, Utilities\Util $util){
        $this->util = $util;
        parent::__construct($dataSourceManager,$parameterBag);
    }
    
    public function findConsRestricao (DTO\Request\Filter $request, DTO\Response $response){
        $conditions = $this->util->getParamsAsArray($request);
        
        $dataSourceFilter = array();
        $likeableConditions = $this->util->getLikeConditions($request);
        foreach ($likeableConditions as $condition) {
			if(array_key_exists($condition['columnName'], $conditions)) {
				 unset($conditions[$condition['columnName']]);
			}
		}
		$conditions = $this->util->buildParams('CDTIPOCONS',$conditions);
        $conditions = $this->util->buildParams('CDCCUSCLIE',$conditions);
        $newRequest = $this->util->createNewZeedhiFilterRequestObject($request, $this->dataSourceName, $conditions);
        foreach ($likeableConditions as $condition) {
			$newRequest->getFilterCriteria()->addCondition($condition['columnName'], $condition['operator'], $condition['value']);
		}
        parent::find($newRequest, $response);
    }
}