<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DTO;
use Teknisa\MAN\Services;

class TipoConsumidor extends CrudWithParameterBag {
    const TIPOCONSBYCLI = 'paraNoCash_tipoConsByCli';
    
    protected $dataSourceName = 'vnd02700_tipocons';
    protected $parameterBagColumns = ['NRORG'];
    
    public function __construct(Manager $dataSourceManager,ParameterBag $parameterBag, Services\FileUploaderService $fileUploaderService) {
        parent::__construct($dataSourceManager, $parameterBag);
        $this->fileUploaderService = $fileUploaderService;
    }
     
    public function getConsumerByCli(DTO\Request\Filter $request, DTO\Response $response)  {
        $this->dataSourceName = TipoConsumidor::TIPOCONSBYCLI;
        $this->parameterBagColumns = array('NRORG', 'CDCLIENTE');
        
        parent::find($request, $response);
    }
    
    public function savePermissoesConsumidor(DTO\Request $request, DTO\Response $response) {
        $this->dataSourceName = TipoConsumidor::TIPOCONSBYCLI;
        $row = $request->getDataSet()->getRows()[0];
        $this->fileUploaderService->setImageForSave($row, 'DSENDPDF', 'DSENDPDF');
        self::saveWithoutNotification($request, $response);
	}
	
	public function saveWithoutNotification(DTO\Request $request, DTO\Response $response) {
        try {
            $dataSet = $request->getDataSet();
            $dataSet->setDataSourceName($this->dataSourceName);
            $persistedRows = $this->dataSourceManager->persist($dataSet);
            $response->addDataSet(new DataSet($this->dataSourceName, $persistedRows));
            $nrPersistedRows = count($persistedRows);
        } catch (\Exception $e) {
            $response->setCriticalError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
    }
}