<?php

namespace Teknisa\MAN\Factories;

use Doctrine\DBAL\Connection;
use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class GeralFilialRepository {

    protected $connection;
    protected $entityManager;

    public function __construct(Connection $connection, EntityManager $entityManager) {
        $this->connection = $connection;
        $this->entityManager = $entityManager;
    }

    public function executeQuery($query){
    	return $this->connection->fetchAll($query);
    }
    

    public function GetNextIdPk($table, $pk){
    	$namePk = $pk[0];
    	$queryToNextId = "SELECT MAX(".$namePk.") AS MAX_NUM FROM ".$table;
    	$nextId = $this->connection->fetchAll($queryToNextId);
    	$nextId = $nextId[0]['MAX_NUM'];
        if ($nextId == null){
            $nextId = 1;
        }
        else {
            $nextId++;
        }
        $pk = [];
        array_push($pk, $namePk, $nextId);
    	return $pk;
    }

    public function Save($queryToSave){
        try{
    	    $this->connection->fetchAll($queryToSave);
        }
        catch(\Exception $e){
            $message = $e->getMessage();
            return false;
        }
    }

    public function Execute($queryToExecute){
        $dataSet = array();
        try{
            $this->entityManager->getConnection()->beginTransaction();   //--- Começa uma transação sem auto commit  no banco
            foreach ($queryToExecute as $query) {
                $this->connection->executeUpdate($query);
            }
            $this->entityManager->getConnection()->commit(); //---- Grava a transação de fato no banco (commit)
            array_push($dataSet, true);
            return $dataSet; 
        }catch(\Exception $e){
            $message = $e->getMessage();
            $this->entityManager->getConnection()->rollBack(); //--- Descarta a transação
            array_push($dataSet, false, $message);
            return $dataSet; 
        }
    }
} 